package ch.hslu.dmg.g06.data;

import java.io.Serializable;

import javax.persistence.*;

@Entity
@Table(name = "KannBedienen")
@NamedQueries({ @NamedQuery(name = "CanUse.getAll", query = "SELECT c FROM CanUse c"),
				@NamedQuery(name = "CanUse.getPossibleEmployees", query = "SELECT c FROM CanUse c WHERE c.machine.id = :id") })
public class CanUse implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "Id")
	private int id;
	
	@JoinColumn(name = "MitarbeiterId", referencedColumnName = "Id")
	@ManyToOne(optional = false)
	private Employee employee;
	
	@JoinColumn(name = "MaschineId", referencedColumnName = "Id")
	@ManyToOne
	private Machine machine;
	
	
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Employee getEmployee() {
		return employee;
	}

	public void setEmployee(Employee employee) {
		this.employee = employee;
	}

	public Machine getMachine() {
		return machine;
	}

	public void setMachine(Machine machine) {
		this.machine = machine;
	}
	
	@Override
	public String toString() {
		
		return "KannBedienen (Id: " + id + ")";
		///return "KannBedienen (" + machine + "; " + employee + ")";
	}
}
