package ch.hslu.dmg.g06.data;

import java.io.Serializable;
import java.util.List;

import javax.persistence.*;

@Entity
@Table(name = "Mitarbeiter")
public class Employee  implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "Id")
	private int id;
	
	@Basic(optional = false)
	@Column(name = "Vorname")
	private String prename;
	
	@Basic(optional = false)
	@Column(name = "Nachname")
	private String surname;
	
	@Basic(optional = false)
	@Column(name = "Adresse")
	private String address;
	
	@Basic(optional = false)
	@Column(name = "Gehalt")
	private float salary;
	
	@Basic(optional = false)
	@Column(name = "Bankverbindung")
	private String bancAccount;
	
	@ManyToMany
	@JoinTable(name="KannBedienen",
			   joinColumns={@JoinColumn(name="MitarbeiterId", referencedColumnName="Id")},
			   inverseJoinColumns={@JoinColumn(name="MaschineId", referencedColumnName="Id")})
	private List<Machine> canUse;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getPrename() {
		return prename;
	}

	public void setPrename(String prename) {
		this.prename = prename;
	}

	public String getSurname() {
		return surname;
	}

	public void setSurname(String surname) {
		this.surname = surname;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public float getSalary() {
		return salary;
	}

	public void setSalary(float salary) {
		this.salary = salary;
	}

	public String getBancAccount() {
		return bancAccount;
	}

	public void setBancAccount(String bancAccount) {
		this.bancAccount = bancAccount;
	}

	public List<Machine> getCanUse() {
		return canUse;
	}

	public void setCanUse(List<Machine> canUse) {
		this.canUse = canUse;
	}
	
	@Override
	public String toString() {
		
		return "Angestellter (Id: " + id + ")";
		//return "Angestellter (Id " + id + "; Vorname " + prename + "; Nachname " + surname + ")";
	}
}
