package ch.hslu.dmg.g06.data;

import java.io.Serializable;
import java.sql.Date;

import javax.persistence.*;

@Entity
@Table(name = "FertigungsSchritt")
@NamedQueries({ @NamedQuery(name = "ProductionStep.getAll", query = "SELECT p FROM ProductionStep p"),
				@NamedQuery(name = "ProductionStep.employeeIsBusy", query = "SELECT p FROM ProductionStep p WHERE p.employee.id = :id AND p.date = :date"),
				@NamedQuery(name = "ProductionStep.machineIsInUse", query = "SELECT p FROM ProductionStep p WHERE p.machine.id = :id AND p.date = :date") })
public class ProductionStep  implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "Id")
	private int id;
	
	@JoinColumn(name = "MitarbeiterId", referencedColumnName = "Id")
	@ManyToOne(optional = false)
	private Employee employee;
	
	@JoinColumn(name = "MaschineId", referencedColumnName = "Id")
	@ManyToOne(optional = false)
	private Machine machine;
	
	@JoinColumn(name = "TeilId", referencedColumnName = "Id")
	@ManyToOne(optional = false)
	private Part part;
	
	@Basic(optional = false)
	@Column(name = "Datum")
	private Date date;
	
	

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Employee getEmployee() {
		return employee;
	}

	public void setEmployee(Employee employee) {
		this.employee = employee;
	}

	public Part getPart() {
		return part;
	}

	public void setPart(Part part) {
		this.part = part;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Machine getMachine() {
		return machine;
	}

	public void setMachine(Machine machine) {
		this.machine = machine;
	}
	
	@Override
	public String toString() {
		
		return "Produktionsschritt (Id: " + id + ")";
		
		//return "Produktionsschritt (Id " + id + "; Datum " + DateUtils.formatDate(date) +  
		//		"; " + machine + "; " + employee + "; " + part + ")";
	}
}